import { HazelReader, HazelWriter } from "@skeldjs/util";
import { Hostable } from "../Hostable";
import { VoteStateSpecialId } from "./PlayerVoteState";
export declare class PlayerVoteArea<RoomType extends Hostable = Hostable> {
    readonly room: RoomType;
    playerId: number;
    votedForId: number;
    didReport: boolean;
    dirty: boolean;
    constructor(room: RoomType, playerId: number, votedForId: number, didReport: boolean);
    /**
     * The player that this vote state is for.
     */
    get player(): import("..").PlayerData<RoomType> | undefined;
    /**
     * Whether the player that this state represents is dead.
     */
    get isDead(): boolean;
    /**
     * Whether this player didn't vote by the end of the meeting.
     */
    get didMissVote(): boolean;
    /**
     * Whether this player skipped voting.
     */
    get didSkip(): boolean;
    /**
     * Whether this player has either voted for a player or voted to skip.
     */
    get hasVoted(): boolean;
    /**
     * The player that this player voted for, if any.
     */
    get votedFor(): import("..").PlayerData<RoomType> | undefined;
    static Deserialize<RoomType extends Hostable = Hostable>(reader: HazelReader, room: RoomType, playerId: number): PlayerVoteArea<RoomType>;
    Serialize(writer: HazelWriter): void;
    clearVote(): void;
    setSkipped(): void;
    setDead(): VoteStateSpecialId;
    setSuspect(playerId: number): void;
}
